(function () {
    "use strict";

    angular.module('pos').controller('relatorioRankingDeVendedorController', controller);
    controller.$inject = ['$scope', '$window', '$state', 'relatorioService', '$timeout'];

    function controller($scope, $window, $state, relatorioService, $timeout) {
        $scope.$parent.initializeLayout('Relatório');

        $scope.printPdf = function (showDetails) {
            $timeout(function () {
                window.print();
            }, 2000);
        };

        $scope.state = {
            vendedores: {
                chart: { data: [], carregando: false, vazio: true },
                report: { data: [], carregando: false, vazio: true },
                totais: { representatividade: 0 },
                filtro: {},
            },
        }

        function getDateWithoutTime(date) {
            var dateObj = new Date(date);
            var dateWithoutTime = dateObj.toLocaleDateString();

            return dateWithoutTime;
        }

        $scope.initialize = function () {
            $scope.clearFilter();
        };
        $scope.historyBack = function () {
            $window.history.back();
        };

        $scope.getTicket = function () {
            $scope.state.vendedores.report.carregando = true;
            $scope.state.vendedores.report.vazio = false;
            relatorioService
                .getTopNVendedores($scope.state.vendedores.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.$parent.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        }
                        else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.vendedores.report.data);
                            $scope.state.vendedores.report.vazio = (!response.Data || response.Data.length == 0);
                        }
                        $scope.totalizar(response.Data);
                        $scope.state.vendedores.report.carregando = false;
                    },
                    function (error) {
                        $scope.$parent.toastr.error('Ao carregar o gráfico.', 'Comunicação com o servidor');
                        console.error(error);
                        $scope.state.vendedores.report.carregando = false;
                    }
                );
        };
        $scope.totalizar = function (data) {
            $scope.state.vendedores.totais.representatividade = 0;

            if (!data)
                return;

            for (var i = 0; i < data.length; i++) {
                $scope.state.vendedores.totais.representatividade += data[i].Representatividade;
            }
        }

        $scope.toggleFilter = function () {
            $scope.state.vendedores.filtro.ativo = !$scope.state.vendedores.filtro.ativo;
        };
        $scope.clearFilter = function () {
            $scope.state.vendedores.filtro = {
                take: 10,
                emissao: {
                    de: new Date((new Date()).getFullYear(), 0, 1), //primeiro dia do ano
                    ate: null
                },
                codigoTerminal: '',
                periodoFechamento: '',
                codigoVendedor: '',
                ativo: false,
            }

            $scope.state.vendedores.filtro.emissao.de = ($scope.$parent.config.VisualizaVendasDia ? new Date() : $scope.state.vendedores.filtro.emissao.de);
            $scope.refresh();
        };

        $scope.refresh = function () {
            
            if ($scope.state.vendedores.filtro.emissao.de) {
                var emissaoDe = $scope.state.vendedores.filtro.emissao.de;
                var emissaoDeNoTime = getDateWithoutTime(emissaoDe);
                $scope.state.vendedores.filtro.emissao.de = emissaoDeNoTime;
            }

            if ($scope.state.vendedores.filtro.emissao.ate) {
                var emissaoAte = $scope.state.vendedores.filtro.emissao.ate;
                var emissaoAteNoTime = getDateWithoutTime(emissaoAte);
                $scope.state.vendedores.filtro.emissao.ate = emissaoAteNoTime;
            }

            $scope.getTicket();
        };

        $scope.initialize();

    }

})();